//+------------------------------------------------------------------+
//|                                                   _RS_Analiz.mq4 |
//|                                                       favoritefx |
//|                                               favoritefx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "favoritefx"
#property link      "favoritefx@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red

//---- input parameters
extern int       HerstPeriod=100;
extern double    a=0.5;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
datetime BarTime=0;
double Price[];

bool isNewBar()
  {
//----
   bool res=false; 
   if (BarTime!=Time[0]) 
      {
         BarTime=Time[0];  
         res=true;
      } 
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel( 0, "Herst");
   
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();
   if (counted_bars==0)   
      limit=Bars-1;
   if (counted_bars>0)      
      limit = Bars - counted_bars-1;
   
   double sum;
   double Average;
   if (isNewBar())
   {
      double MaxH;
      double MinH;
      double R;
      int i;      
      for(int j=limit;j>=0;j--)
      {
         ExtMapBuffer2[j]=Close[j]-Close[j+1];
         int max_index=ArrayMaximum(ExtMapBuffer2,HerstPeriod+j,j);
         int min_index=ArrayMinimum(ExtMapBuffer2,HerstPeriod+j,j);
         MaxH=ExtMapBuffer2[max_index];
         MinH=ExtMapBuffer2[min_index];
         R=MaxH-MinH;
         for (i=1;i<=HerstPeriod;i++)
            sum+=ExtMapBuffer2[i+j];
         Average=sum/HerstPeriod;
         sum=0;
         for (i=1;i<=HerstPeriod;i++)
             sum+=MathPow((Average-ExtMapBuffer2[i+j]),2);
         double S=MathSqrt(sum/(HerstPeriod-1));
         if (S>0)
            ExtMapBuffer1[j]=(MathLog(R/S))/(MathLog(HerstPeriod*a));    
      }
   }
   return(0);
  }
//+------------------------------------------------------------------+